﻿Imports System.Speech.Recognition
Imports System.Speech.Recognition.SrgsGrammar

Public Class Form1
    Private recognizer As SpeechRecognizer
    Dim TV As New GrammarBuilder
    Dim channel As New GrammarBuilder
    Public Sub New()
        InitializeComponent()
        recognizer = New SpeechRecognizer
        AddHandler recognizer.SpeechRecognized, AddressOf recognizer_SpeechRecognized
        TV.Append(New Choices("tv", "power", "on", "off", "volume up", "volume down", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "40", "41", "42", "43", "44", "45", "46", "47", "48", "49", "50", "51", "52", "53", "54", "55", "56", "57", "58", "59", "60", "61", "62", "63", "64", "65", "66", "67", "68", "69", "70", "71", "72", "73", "74", "75", "76", "77", "78", "79", "80", "81", "82", "83", "84", "85", "86", "87", "88", "89", "90", "91", "92", "93", "94", "95", "96", "97", "98", "99")) '"channel"))
        'channel.Append(New Choices("1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "40", "41", "42", "43", "44", "45", "46", "47", "48", "49", "50", "51", "52", "53", "54", "55", "56", "57", "58", "59", "60", "61", "62", "63", "64", "65", "66", "67", "68", "69", "70", "71", "72", "73", "74", "75", "76", "77", "78", "79", "80", "81", "82", "83", "84", "85", "86", "87", "88", "89", "90", "91", "92", "93", "94", "95", "96", "97", "98", "99"))
        recognizer.LoadGrammar(New Grammar(TV))
    End Sub
    Private Sub recognizer_SpeechRecognized(ByVal sender As Object, ByVal e As SpeechRecognizedEventArgs)
        SerialPort1.Open()
        If SerialPort1.IsOpen = True Then
            If e.Result.Text = "power" Or e.Result.Text = "on" Or e.Result.Text = "off" Then
                SerialPort1.Write("p")
            ElseIf e.Result.Text = "volume up" Then
                SerialPort1.WriteLine("u")
            ElseIf e.Result.Text = "volume down" Then
                SerialPort1.WriteLine("d")
            ElseIf e.Result.Text = "channel" Then
                recognizer.UnloadAllGrammars()
                recognizer.LoadGrammar(New Grammar(channel))
                channelTimer.Enabled = True
            ElseIf e.Result.Text = "last" Then
                SerialPort1.WriteLine("l")
            Else
                SerialPort1.WriteLine(e.Result.Text)
            End If
        End If
        Me.Focus()
        SerialPort1.Close()
    End Sub
    Private Sub channelTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles channelTimer.Tick
        recognizer.UnloadAllGrammars()
        recognizer.LoadGrammar(New Grammar(TV))
        channelTimer.Enabled = False
    End Sub
    Private Sub btnPower_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPower.Click
        SerialPort1.Open()
        SerialPort1.WriteLine("p")
        SerialPort1.Close()
        Me.Focus()
    End Sub
    Private Sub btnVolDwn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnVolDwn.Click
        SerialPort1.Open()
        SerialPort1.WriteLine("d")
        SerialPort1.Close()
        Me.Focus()
    End Sub
    Private Sub btnVolUp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnVolUp.Click
        SerialPort1.Open()
        SerialPort1.WriteLine("u")
        SerialPort1.Close()
        Me.Focus()
    End Sub
    Private Sub btnOne_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOne.Click
        SerialPort1.Open()
        SerialPort1.WriteLine("1")
        SerialPort1.Close()
        Me.Focus()
    End Sub
    Private Sub btnTwo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTwo.Click
        SerialPort1.Open()
        SerialPort1.WriteLine("2")
        SerialPort1.Close()
        Me.Focus()
    End Sub
    Private Sub btnThree_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnThree.Click
        SerialPort1.Open()
        SerialPort1.WriteLine("3")
        SerialPort1.Close()
        Me.Focus()
    End Sub
    Private Sub btnFour_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFour.Click
        SerialPort1.Open()
        SerialPort1.WriteLine("4")
        SerialPort1.Close()
        Me.Focus()
    End Sub
    Private Sub btnFive_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFive.Click
        SerialPort1.Open()
        SerialPort1.WriteLine("5")
        SerialPort1.Close()
        Me.Focus()
    End Sub
    Private Sub btnSix_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSix.Click
        SerialPort1.Open()
        SerialPort1.WriteLine("6")
        SerialPort1.Close()
        Me.Focus()
    End Sub
    Private Sub btnSeven_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSeven.Click
        SerialPort1.Open()
        SerialPort1.WriteLine("7")
        SerialPort1.Close()
        Me.Focus()
    End Sub
    Private Sub btnEight_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEight.Click
        SerialPort1.Open()
        SerialPort1.WriteLine("8")
        SerialPort1.Close()
        Me.Focus()
    End Sub
    Private Sub btnNine_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNine.Click
        SerialPort1.Open()
        SerialPort1.WriteLine("9")
        SerialPort1.Close()
        Me.Focus()
    End Sub
    Private Sub btnZero_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnZero.Click
        SerialPort1.Open()
       SerialPort1.WriteLine("0")
        SerialPort1.Close()
        Me.Focus()
    End Sub
    Private Sub btnLast_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLast.Click
        SerialPort1.Open()
        SerialPort1.WriteLine("l")
        SerialPort1.Close()
        Me.Focus()
    End Sub
    Private Sub btnChUp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnChUp.Click
        SerialPort1.Open()
        SerialPort1.WriteLine("n")
        SerialPort1.Close()
        Me.Focus()
    End Sub
    Private Sub btnChDwn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnChDwn.Click
        SerialPort1.Open()
       SerialPort1.WriteLine("b")
        SerialPort1.Close()
        Me.Focus()
    End Sub
    Private Sub btnMute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMute.Click
        SerialPort1.Open()
        SerialPort1.WriteLine("m")
        SerialPort1.Close()
        Me.Focus()
    End Sub
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Form2.Show()
        Me.Hide()
    End Sub

    Private Sub Form1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Click
        Me.Focus()
    End Sub

    Private Sub Form1_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles Me.KeyPress
        MessageBox.Show(e.KeyChar)
    End Sub
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            For i = 0 To 25
                Try
                    SerialPort1.PortName = "COM" & i
                    SerialPort1.Open()
                    ComboBox1.Items.Add("COM" & i)
                Catch ex As Exception
                End Try
                Me.Focus()
                SerialPort1.Close()
            Next
            ComboBox1.SelectedIndex = 0
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        SerialPort1.PortName = ComboBox1.SelectedItem
    End Sub
End Class